' GW2ASC 0.10  (c)2020 PeatSoft

' Modified version of
'    READBAS 1.1 -  READS BASIC PROGRAMS SAVED IN BINARY
'    NELSON FORD (713) 960-1300   (713) 721-6104    APRIL 11,1985
'    PUBLIC DOMAIN

DEFINT A-Z

DIM T$(116), T3$(6), T4$(30), T5$(37)
DIM x#(8)
DIM isuni AS INTEGER

a1$ = COMMAND$: a2 = 1: tfix = 0
a13 = 0
isuni = 0

DO
   a3 = INSTR(a2, a1$, " ")
   IF a3 THEN
      a$ = MID$(a1$, a2, a3 - a2): a2 = a3 + 1
   ELSE
      a$ = RIGHT$(a1$, LEN(a1$) + 1 - a2)
   END IF
   IF a$ = "/F" THEN tfix = 1
   IF a$ <> "" AND LEFT$(a$, 1) <> "/" THEN
      IF file$ = "" THEN
         file$ = a$
      ELSE
         IF ofile$ = "" THEN
            ofile$ = a$
         END IF
      END IF
   END IF
LOOP UNTIL a3 = 0

'tfix = 1
'file$ = "c:\gw2asc09\circles.bas"

IF file$ = "" THEN
   PRINT "GW2ASC 0.10  (c)2020 PeatSoft"
   PRINT "  Modified version of READBAS 1.1  (c) NELSON FORD (APRIL 11,1985)"
   PRINT "   License: PUBLIC DOMAIN"
   PRINT "  Internet: www.xs4all.nl/~hwiegman/gwbasic.html"
   PRINT "     Email: hwiegman@xs4all.nl"
   PRINT
   PRINT "   Usage: GW2ASC basfile [outfile] [options]"
   PRINT "Examples: GW2ASC test.bas, GW2ASC test.bas fixed.bas"
   PRINT " Options: /f   Try to fix corrupted files"
   END
END IF
    
out1$ = ofile$
IF ofile$ = "" THEN
   file1$ = file$: f1 = INSTR(1, file$, ".")
   IF f1 THEN file1$ = LEFT$(file$, f1 - 1)
   out1$ = file1$ + ".ASC"
END IF

' tokens 129-244
FOR T = 129 TO 244
   READ T$(T - 128)
NEXT

' token 253 followed by 129-134
FOR T = 129 TO 134
   READ T3$(T - 128)
NEXT

' token 254 followed by 129-158
FOR T = 129 TO 158
   READ T4$(T - 128)
NEXT

' token 255 followed by 129-165
FOR T = 129 TO 165
   READ T5$(T - 128)
NEXT

OPEN file$ FOR BINARY AS #1
   x1$ = SPACE$(LOF(1))
   GET #1, , x1$
CLOSE #1

xx = 1
x$ = MID$(x1$, xx, 1)
xx = xx + 1
IF ASC(x$) <> 255 THEN
   IF ASC(x$) = 254 THEN
      PRINT "File is protected"
   ELSE
      PRINT "no Binary GWBasic file"
   END IF
   END
END IF

OPEN out1$ FOR OUTPUT AS #2
130 ' get, print line number
   x$ = MID$(x1$, xx, 1): xx = xx + 1
   x = ASC(x$)
   x$ = MID$(x1$, xx, 1): xx = xx + 1

   IF x = 13 AND ASC(x$) = 10 THEN
      a13 = 1
      IF tfix = 1 THEN
         x = ASC(x$)
         x$ = MID$(x1$, xx, 1): xx = xx + 1
      END IF
   END IF
  
   IF x = 0 AND ASC(x$) = 0 THEN
      CLOSE #2
      PRINT file$ + " converted into " + out1$
      IF tfix = 0 AND a13 = 1 THEN
         PRINT
         PRINT "ATTENTION: File is corrupt"
         PRINT "Try again with the /F switch"
      END IF
      END
   END IF
  
   x$ = MID$(x1$, xx, 1): xx = xx + 1
   n$ = STR$(ASC(x$))
   x$ = MID$(x1$, xx, 1): xx = xx + 1
   x = ASC(x$)

   IF xx < 7 AND x = 10 AND VAL(n$) = 13 THEN
      a13 = 1
      IF tfix = 1 THEN
         n$ = STR$(ASC(x$))
         x$ = MID$(x1$, xx, 1): xx = xx + 1
         x = ASC(x$)
      END IF
   END IF
  
   IF x > 0 THEN
      n$ = STR$(x * 256& + VAL(n$))
   END IF
   PRINT #2, RIGHT$(n$, LEN(n$) - 1); " ";

200 ' get a hex character and translate
   x$ = MID$(x1$, xx, 1): xx = xx + 1
   x = ASC(x$)
  
   IF x = 58 THEN
      x$ = MID$(x1$, xx, 1): xx = xx + 1
      x = ASC(x$)
      IF x = 143 THEN
         n$ = ":REM "
         GOSUB 910
         GOTO 130
      ELSE
         PRINT #2, ":";
      END IF
   ELSE
      If x = 143 THEN
         n$ = "REM "
         GOSUB 910
         GOTO 130
      End If
   END IF

'ascii 0 marks end of BASIC line
   IF x = 0 THEN
      PRINT #2, ""
      isuni = 0
      GOTO 130
   END IF
  
   IF x > 31 THEN
      GOTO 300
   END IF
  
   IF x > 0 AND x < 7 THEN
      GOTO 300
   END IF

   IF x < 11 THEN
      a13 = 1
      GOTO 200
   END IF
  
   ON x - 10 GOSUB 400, 440, 480, 500, 540, 580, 600, 600, 600, 600, 600, 600, 600, 600, 600, 600, 640, 660, 720, 815, 820
   GOTO 200

300
   IF x < 128 THEN
      IF x = 34 THEN isuni = isuni + 1
      PRINT #2, x$;
      GOTO 200
   END IF

   IF x > 128 AND x < 245 THEN
      IF isuni / 2 <> INT(isuni / 2) THEN
         PRINT #2, x$;
      ELSE
         PRINT #2, T$(x - 128);
      END IF
      GOTO 200
   END IF
  
   IF x > 252 AND x < 256 THEN
      x$ = MID$(x1$, xx, 1): xx = xx + 1
      Y = ASC(x$)
   ELSE
      GOTO 200
   END IF
  
   IF Y < 129 THEN
      GOTO einde
   END IF
  
   ON x - 252 GOTO 350, 360, 370
   GOTO 200

350
   PRINT #2, T3$(Y - 128);
   GOTO 200

360
   PRINT #2, T4$(Y - 128);
   GOTO 200

370
   PRINT #2, T5$(Y - 128);
   GOTO 200

400 '11  =  OCTAL
   x$ = MID$(x1$, xx, 1): xx = xx + 1
   n = x
   x$ = MID$(x1$, xx, 1): xx = xx + 1
   n = x * 256 + n
   PRINT #2, "&O"; OCT$(n);
   RETURN

440 '12  =  HEX
   x$ = MID$(x1$, xx, 1): xx = xx + 1
   n = x
   x$ = MID$(x1$, xx, 1): xx = xx + 1
   n = x * 256 + n
   PRINT #2, "&H"; HEX$(n);
   RETURN

480 '13  NOT USED
   GOTO einde

500 '14  INTEGERS
   x$ = MID$(x1$, xx, 1): xx = xx + 1
   n$ = STR$(ASC(x$))
   x$ = MID$(x1$, xx, 1): xx = xx + 1
   x = ASC(x$)
   IF x > 0 THEN
      n$ = STR$(x * 256 + VAL(n$))
   END IF
   PRINT #2, RIGHT$(n$, LEN(n$) - 1);
   RETURN

540 '15  =  NUMBERS 10 TO 255
   x$ = MID$(x1$, xx, 1): xx = xx + 1
   n$ = STR$(ASC(x$))
   PRINT #2, RIGHT$(n$, LEN(n$) - 1);
   RETURN

580 '16  NOT USED
   GOTO einde

600 '17 - 26 = NUMBERS 0 TO 9
   n$ = STR$(x - 17)
   PRINT #2, RIGHT$(n$, LEN(n$) - 1);
   RETURN

640 '27  NOT USED
   GOTO einde

660 '28  =  NUMBERS > 255 AND <32267
   x$ = MID$(x1$, xx, 1): xx = xx + 1
   n = ASC(x$)
   x$ = MID$(x1$, xx, 1): xx = xx + 1
   n$ = STR$(256 * ASC(x$) + n)
   PRINT #2, RIGHT$(n$, LEN(n$) - 1);
   RETURN

720 ' 29  =  SINGLE PRECISION
   FOR I = 1 TO 4
      x$ = MID$(x1$, xx, 1): xx = xx + 1
      x#(I) = ASC(x$)
   NEXT
   Z$ = ""
   FOR J = 3 TO 1 STEP -1
      Y# = x#(J)
      FOR I = 7 TO 0 STEP -1
         IF Y# > 2 ^ I - 1 THEN
            Z$ = Z$ + "1"
            Y# = Y# - 2 ^ I
         ELSE
            Z$ = Z$ + "0"
         END IF
      NEXT
   NEXT
   n# = 1
   Z$ = RIGHT$(Z$, 23)
   FOR I = 1 TO 23
      n# = n# + VAL(MID$(Z$, I, 1)) * .5 ^ I
   NEXT
   n$ = STR$(CSNG(n# * 2 ^ (x#(4) - 129)))
   PRINT #2, RIGHT$(n$, LEN(n$) - 1); "!";
   RETURN

815 ' 30  NOT USED

820 ' 31  =  DOUBLE PRECISION
   FOR I = 1 TO 8
      x$ = MID$(x1$, xx, 1): xx = xx + 1
      x#(I) = ASC(x$)
   NEXT
   Z$ = ""
   FOR J = 7 TO 1 STEP -1
      Y# = x#(J)
      FOR I = 7 TO 0 STEP -1
         IF Y# > 2 ^ I - 1 THEN
            Z$ = Z$ + "1"
            Y# = Y# - 2 ^ I
         ELSE
            Z$ = Z$ + "0"
         END IF
      NEXT
   NEXT
   n# = 1
   Z$ = RIGHT$(Z$, 55)
   FOR I = 1 TO 55
      n# = n# + VAL(MID$(Z$, I, 1)) * .5 ^ I
   NEXT
   n$ = STR$(n# * 2 ^ (x#(8) - 129))
   PRINT #2, RIGHT$(n$, LEN(n$) - 1); "#";
   RETURN

' read from ' to end of line
910
   x$ = MID$(x1$, xx, 1): xx = xx + 1
   IF x$ = CHR$(217) THEN
      n$ = "' "
   END IF
   PRINT #2, n$;
   IF x$ = CHR$(0) THEN
      PRINT #2, ""
      RETURN
   END IF
920
   x$ = MID$(x1$, xx, 1): xx = xx + 1
   IF ASC(x$) > 0 THEN
      PRINT #2, x$;
      GOTO 920
   END IF
   PRINT #2, ""
   RETURN

einde:
CLOSE #2
KILL out1$
PRINT "Error in file"
PRINT "Position:"; xx
END

' tokens 129-244:
DATA END,FOR,NEXT,DATA,INPUT,DIM,READ,LET,GOTO,RUN,IF,RESTORE,GOSUB,RETURN
DATA REM,STOP,PRINT,CLEAR,LIST,NEW,ON,WAIT,DEF,POKE,CONT,NU,NU,OUT,LPRINT
DATA LLIST,NU,WIDTH,ELSE,TRON,TROFF,SWAP,ERASE,EDIT,ERROR,RESUME,DELETE
DATA AUTO,RENUM,DEFSTR,DEFINT,DEFSNG,DEFDBL,LINE,WHILE,WEND,CALL,NU,NU,NU
DATA WRITE,OPTION,RANDOMIZE,OPEN,CLOSE,LOAD,MERGE,SAVE,COLOR,CLS,MOTOR
DATA BSAVE,BLOAD,SOUND,BEEP,PSET,PRESET,SCREEN,KEY,LOCATE,NU,TO,THEN,TAB(
DATA STEP,USR,FN,SPC,NOT,ERL,ERR,STRING$,USING,INSTR,"'",VARPTR,CSRLIN
DATA POINT, OFF,INKEY$,NU,NU,NU,NU,NU,NU,NU,>,=,<,+,-,*,/,^,AND,OR,XOR,EQV
DATA IMP,MOD,"\"

' pre-token 253, tokens 129-134:
DATA CVI,CVS,CVD,MKI$,MKS$,MKD$

' pre-token 254, tokens 129-158:
DATA FILES,FIELD,SYSTEM,NAME,LSET,RSET,KILL,PUT,GET,RESET,COMMON,CHAIN
DATA DATE$,TIME$,PAINT,COM,CIRCLE,DRAW,PLAY,TIMER,ERDEV,IOCTL,CHDIR,MKDIR
DATA RMDIR,SHELL,ENVIRON,VIEW,WINDOW,PMAP

' pre-token 255, tokens 129-165:
DATA LEFT$,RIGHT$,MID$,SGN,INT,ABS,SQR,RND,SIN,LOG,EXP,COS,TAN,ATN,FRE
DATA INP,POS,LEN,STR$,VAL,ASC,CHR$,PEEK,SPACE$,OCT$,HEX$,LPOS,CINT,CSNG
DATA CDBL,FIX,PEN,STICK,STRIG,EOF,LOC,LOF

